clear;
close all;
clc;
figure_print=1;

import freq_data_tools;
%%

dat11=importdata('./liso/D060572_run11.out');
dat21=importdata('./liso/D060572_run21.out');
dat31=importdata('./liso/D060572_run31.out');
dat41=importdata('./liso/D060572_run41.out');
dat51=importdata('./liso/D060572_run51.out');
dat61=importdata('./liso/D060572_run61.out');

%%
tf11=freq_data_tools('dbdeg',dat11.data);
tf21=freq_data_tools('dbdeg',dat21.data);
tf31=freq_data_tools('dbdeg',dat31.data);
tf41=freq_data_tools('dbdeg',dat41.data);
tf51=freq_data_tools('dbdeg',dat51.data);
tf61=freq_data_tools('dbdeg',dat61.data);

%%

hh=figure(1);
clf;

orient landscape;
hh.PaperSize = [11 8];
hh.PaperPositionMode= 'manual';
hh.PaperPosition = [0 0 11 8];

subplot(3,1,[1 2])

loglog(tf11.freq, tf11.abs,'-','Color',hsv2rgb(0,1,.7));
hold on
loglog(tf21.freq, tf21.abs,'-','Color',hsv2rgb(0.1,1,.7));
loglog(tf31.freq, tf31.abs,'-','Color',hsv2rgb(0.2,1,.7));
loglog(tf41.freq, tf41.abs,'-','Color',hsv2rgb(0.3,1,.7));
loglog(tf51.freq, tf51.abs,'-','Color',hsv2rgb(0.4,1,.7));
loglog(tf61.freq, tf61.abs,'-','Color',hsv2rgb(0.5,1,.7));
grid on;
% xlim([1e6,150e6]);
ylim([10,1e6]);
% xlabel('\bfFrequency [Hz]');
ylabel('\bfTransimpedance [Ohm]');
set(gca,'FontSize',14);
hl=legend(...
    'rT: 10',...
    'rT: 30',...
    'rT: 100',...
    'rT: 300',...
    'rT: 1k',...
    'rT: 3k',...
    'Location','NorthWest');
set(hl,'FontSize',10);
title('Total transimpedance (July 2, 2018)');

subplot(3,1,3)
semilogx(tf11.freq, tf11.phs,'-','Color',hsv2rgb(0,1,.7));
hold on
semilogx(tf21.freq, tf21.phs,'-','Color',hsv2rgb(0.1,1,.7));
semilogx(tf31.freq, tf31.phs,'-','Color',hsv2rgb(0.2,1,.7));
semilogx(tf41.freq, tf41.phs,'-','Color',hsv2rgb(0.3,1,.7));
semilogx(tf51.freq, tf51.phs,'-','Color',hsv2rgb(0.4,1,.7));
semilogx(tf61.freq, tf61.phs,'-','Color',hsv2rgb(0.5,1,.7));
grid on
set(gca,'YTick',[-180:60:180]);
% xlim([1e6,150e6]);
ylim([-180 180]);
xlabel('\bfFrequency [Hz]');
ylabel('\bfPhase [Degree]');
set(gca,'FontSize',14);

if figure_print ==1
    print('./transimpedance.pdf','-dpdf','-r600','-opengl');
end
%%

dat12=importdata('./liso/D060572_run12.out');
dat22=importdata('./liso/D060572_run22.out');
dat32=importdata('./liso/D060572_run32.out');
dat42=importdata('./liso/D060572_run42.out');
dat52=importdata('./liso/D060572_run52.out');
dat62=importdata('./liso/D060572_run62.out');

%%
abs12=freq_data_tools('abs',dat12.data);
abs22=freq_data_tools('abs',dat22.data);
abs32=freq_data_tools('abs',dat32.data);
abs42=freq_data_tools('abs',dat42.data);
abs52=freq_data_tools('abs',dat52.data);
abs62=freq_data_tools('abs',dat62.data);

%%

hh=figure(2);
clf;

orient landscape;
hh.PaperSize = [11 8];
hh.PaperPositionMode= 'manual';
hh.PaperPosition = [0 0 11 8];

% subplot(3,1,[1 2])

loglog(abs12.freq, abs12.abs,'-','Color',hsv2rgb(0,1,.7));
hold on
loglog(abs22.freq, abs22.abs,'-','Color',hsv2rgb(0.1,1,.7));
loglog(abs32.freq, abs32.abs,'-','Color',hsv2rgb(0.2,1,.7));
loglog(abs42.freq, abs42.abs,'-','Color',hsv2rgb(0.3,1,.7));
loglog(abs52.freq, abs52.abs,'-','Color',hsv2rgb(0.4,1,.7));
loglog(abs62.freq, abs62.abs,'-','Color',hsv2rgb(0.5,1,.7));

loglog(abs12.freq, sqrt(0.01)*18e-12*abs12.freq./abs12.freq,'k--');
loglog(abs12.freq, sqrt(0.1)*18e-12*abs12.freq./abs12.freq,'k--');
loglog(abs12.freq, 18e-12*abs12.freq./abs12.freq,'k--');
loglog(abs12.freq, sqrt(10)*18e-12*abs12.freq./abs12.freq,'k--');
loglog(abs12.freq, sqrt(100)*18e-12*abs12.freq./abs12.freq,'k--');

text(0.013,1.25e-12,'shotnoise intercept current');
text(0.013,sqrt(0.01)*18e-12*1.2,'10\muA');
text(0.013,sqrt(0.1) *18e-12*1.2,'100\muA');
text(0.013,sqrt(1)   *18e-12*1.2,'1mA');
text(0.013,sqrt(10)  *18e-12*1.2,'10mA');
text(0.013,sqrt(100) *18e-12*1.2,'100mA');

grid on;
% xlim([1e6,150e6]);
ylim([1e-12,1e-8]);
xlabel('\bfFrequency [Hz]');
ylabel('\bfInput equivalent noise current [A/HZ^{1/2}]');
set(gca,'FontSize',14);
hl=legend(...
    'rT: 10',...
    'rT: 30',...
    'rT: 100',...
    'rT: 300',...
    'rT: 1k',...
    'rT: 3k',...
    'Location','NorthEast');
set(hl,'FontSize',10);
title('Input current noise (July 2, 2018)');
xlabel('\bfFrequency [Hz]');
set(gca,'FontSize',14);

if figure_print ==1
    print('./input_current_noise.pdf','-dpdf','-r600','-opengl');
end

%%

dat13=importdata('./liso/D060572_run13.out');
dat23=importdata('./liso/D060572_run23.out');
dat33=importdata('./liso/D060572_run33.out');
dat43=importdata('./liso/D060572_run43.out');
dat53=importdata('./liso/D060572_run53.out');
dat63=importdata('./liso/D060572_run63.out');

amp13=freq_data_tools('abs',dat13.data);
amp23=freq_data_tools('abs',dat23.data);
amp33=freq_data_tools('abs',dat33.data);
amp43=freq_data_tools('abs',dat43.data);
amp53=freq_data_tools('abs',dat53.data);
amp63=freq_data_tools('abs',dat63.data);

%%

hh=figure(3);
clf;

orient landscape;
hh.PaperSize = [11 8];
hh.PaperPositionMode= 'manual';
hh.PaperPosition = [0 0 11 8];

% subplot(3,1,[1 2])

loglog(amp13.freq, amp13.abs,'-','Color',hsv2rgb(0,1,.7));
hold on
loglog(amp23.freq, amp23.abs,'-','Color',hsv2rgb(0.1,1,.7));
loglog(amp33.freq, amp33.abs,'-','Color',hsv2rgb(0.2,1,.7));
loglog(amp43.freq, amp43.abs,'-','Color',hsv2rgb(0.3,1,.7));
loglog(amp53.freq, amp53.abs,'-','Color',hsv2rgb(0.4,1,.7));
loglog(amp63.freq, amp63.abs,'-','Color',hsv2rgb(0.5,1,.7));
grid on;
% xlim([1e6,150e6]);
% ylim([10,1e6]);
% xlabel('\bfFrequency [Hz]');
ylabel('\bfMax input amplitude [A]');
set(gca,'FontSize',14);
hl=legend(...
    'rT: 10',...
    'rT: 30',...
    'rT: 100',...
    'rT: 300',...
    'rT: 1k',...
    'rT: 3k',...
    'Location','SouthWest');
set(hl,'FontSize',10);
title('Linear range against sinusoidal current signal input (July 2, 2018)');
xlabel('\bfFrequency [Hz]');
set(gca,'FontSize',14);

if figure_print ==1
    print('./input_range.pdf','-dpdf','-r600','-opengl');
end
