classdef freq_data_tools
    %UNTITLED Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        freq
        z
    end
    
    methods
        
        function obj = freq_data_tools(arg1,arg2,arg3)
            switch nargin
                case 3
                    obj.freq = arg1;
                    obj.z = arg2 + 1i*arg3;
                    
                case 1
                    obj.freq = arg1(:,1);
                    obj.z = arg1(:,2) + 1i*arg1(:,3);
                    
                otherwise
                    if strcmp(arg1,'dbdeg')
                        obj.freq = arg2(:,1);
                        obj.z = 10.^(arg2(:,2)/20) .* exp(1i*arg2(:,3)/180*pi);
                    elseif strcmp(arg1,'db')
                        obj.freq = arg2(:,1);
                        obj.z = 10.^(arg2(:,2)/20);
                    elseif strcmp(arg1,'abs')
                        obj.freq = arg2(:,1);
                        obj.z = arg2(:,2);
                    else
                        error('Wrong number of input arguments');
                    end
            end
        end
        
        function out = re(obj)
            % real part of the impedance
            out = real(obj.z);
        end
        
        function out = im(obj)
            % real part of the impedance
            out = imag(obj.z);
        end
        
        function out = abs(obj)
            % real part of the impedance
            out = abs(obj.z);
        end
        
        function out = db(obj)
            % real part of the impedance
            out = 20*log10(obj.abs);
        end
        
        function out = phs(obj)
            % real part of the impedance
            out = obj.rad/pi*180;
        end
        
        function out = rad(obj)
            % real part of the impedance
            out = angle(obj.z);
        end
        
        function out = q(obj)
            % real part of the impedance
            out = abs(obj.im./obj.re);
        end
        
        function out = bodesave(obj, fname)
            sav = [obj.freq obj.abs obj.phs];
            save(fname,  'sav', '-ascii', '-tabs');
        end
        
    end
    
    
end
